package meerkat.pollingstation;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.protobuf.PollingStation.*;
/**
 * Created by Arbel on 05/05/2016.
 * An interface for the scanner used by the Polling Station Committee
 */
public interface PollingStationScanner {

    /**
     * Subscribes to new scans
     * @param scanCallback is the handler for scanned data
     */
    public void subscribe(FutureCallback<ScannedData> scanCallback);

    /**
     * Sends a scan to all subscribers
     * @param scannedData contains the scanned data
     */
    public void newScan(ScannedData scannedData);

    /**
     * Notifies subscribers about an error that occurred during scan
     * @param errorMsg is the error that occurred
     */
    public void reportScanError(ErrorMsg errorMsg);

}